Public Member Functions

# MusicTrackSelectionWindow Struct Reference

Inheritance diagram for MusicTrackSelectionWindow:

## Public Member Functions
| MusicTrackSelectionWindow (WindowDesc *desc, WindowNumber number)
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.

## Detailed Description

Definition at line 292 of file music_gui.cpp.

## Member Function Documentation

virtual void MusicTrackSelectionWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 364 of file music_gui.cpp.

References _settings_client, DrawString(), GetSongName(), GetTrackNumber(), GfxFillRect(), ClientSettings::music, NUM_SONGS_AVAILABLE, PC_BLACK, MusicSettings::playlist, SetDParam(), SetDParamStr(), StrEmpty(), WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, WID_MTS_LIST_LEFT, and WID_MTS_LIST_RIGHT.

virtual void MusicTrackSelectionWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 401 of file music_gui.cpp.

References _settings_client, FONT_HEIGHT_SMALL, Window::GetRowFromWidget(), GetTrackNumber(), BaseMedia< MusicSet >::GetUsedSet(), IsInsideMM(), ClientSettings::music, NUM_SONGS_AVAILABLE, NUM_SONGS_PLAYLIST, MusicSettings::playlist, Window::SetDirty(), WID_MTS_ALL, WID_MTS_CLEAR, WID_MTS_CUSTOM1, WID_MTS_CUSTOM2, WID_MTS_EZY, WID_MTS_LIST_LEFT, WID_MTS_LIST_RIGHT, WID_MTS_NEW, and WID_MTS_OLD.

virtual void MusicTrackSelectionWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 316 of file music_gui.cpp.

References _settings_client, ClientSettings::music, MusicSettings::playlist, Window::SetDirty(), Window::SetWidgetDisabledState(), Window::SetWidgetLoweredState(), WID_MTS_ALL, and WID_MTS_CLEAR.

virtual void MusicTrackSelectionWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 302 of file music_gui.cpp.

References _settings_client, ClientSettings::music, MusicSettings::playlist, SetDParam(), and WID_MTS_PLAYLIST.

virtual void MusicTrackSelectionWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 326 of file music_gui.cpp.

References GetSongName(), GetStringBoundingBox(), GetTrackNumber(), max(), maxdim(), NUM_SONGS_AVAILABLE, SetDParam(), SetDParamStr(), StrEmpty(), WID_MTS_LIST_LEFT, WID_MTS_LIST_RIGHT, and WID_MTS_PLAYLIST.

The documentation for this struct was generated from the following file:

- src/music_gui.cpp